<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hcubic.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hcubic.c</h1><a href="hcubic_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2005 Greg Parker</span>
<a name="l00005"></a>00005 <span class="comment">    Copyright (C) 2005-2010 Werner Scholz</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00008"></a>00008 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00011"></a>00011 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00012"></a>00012 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00013"></a>00013 <span class="comment">    (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00016"></a>00016 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00017"></a>00017 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00018"></a>00018 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00021"></a>00021 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00022"></a>00022 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00023"></a>00023 <span class="comment">*/</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hcubic.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00026"></a>00026 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00031"></a>00031 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00032"></a>00032 <span class="keyword">static</span> Vec       VHcubic;
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="keyword">static</span> PetscReal Ecubic;
<a name="l00035"></a>00035 <span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a><a class="code" href="hcubic_8c.html#a01373c5662322678c71a3420ab8b0790">00037</a> <span class="keywordtype">int</span> <a class="code" href="hcubic_8c.html#a01373c5662322678c71a3420ab8b0790">Hcubic_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00042"></a>00042     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+16]==1 ||
<a name="l00043"></a>00043         PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 3]) &gt; <a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00044"></a>00044       <span class="comment">/* FIXME: latter case not really cubic, but hcubic.c calculates the K_2 term</span>
<a name="l00045"></a>00045 <span class="comment">         anisotropy field calculation then off!? Hani calculated twice?</span>
<a name="l00046"></a>00046 <span class="comment">      */</span>
<a name="l00047"></a>00047       fieldon=1;
<a name="l00048"></a>00048       <span class="keywordflow">break</span>;
<a name="l00049"></a>00049     }
<a name="l00050"></a>00050   }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="keywordflow">if</span> (fieldon) {
<a name="l00053"></a>00053     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hcubic on\n&quot;</span>);
<a name="l00054"></a>00054     ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHcubic);CHKERRQ(ierr);
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056   <span class="keywordflow">else</span> {
<a name="l00057"></a>00057     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hcubic off\n&quot;</span>);
<a name="l00058"></a>00058   }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="hcubic_8c.html#ace2ad4bc212a40902a58d3bfdaa0518a">00064</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#ace2ad4bc212a40902a58d3bfdaa0518a">Hcubic</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHtotsum)
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">/* initialize if necessary */</span>
<a name="l00069"></a>00069   <span class="keywordflow">if</span> (doinit) {
<a name="l00070"></a>00070     ierr = <a class="code" href="hcubic_8c.html#a01373c5662322678c71a3420ab8b0790">Hcubic_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00071"></a>00071     doinit=0;
<a name="l00072"></a>00072   }
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00074"></a>00074     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   PetscReal *ta_Hcubic,*ta_M;
<a name="l00078"></a>00078   ierr = VecGetArray(VHcubic,&amp;ta_Hcubic);CHKERRQ(ierr);
<a name="l00079"></a>00079   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>  PetscReal *ta_VMs3;
<a name="l00083"></a>00083   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;ta_VMs3);CHKERRQ(ierr);
<a name="l00084"></a>00084   Ecubic=0.0;
<a name="l00085"></a>00085 <span class="preprocessor">#endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00087"></a>00087   <span class="comment">/* TODO: for nodes at interfaces, the assignment is &quot;at will&quot; */</span>
<a name="l00088"></a>00088   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; j++) {
<a name="l00089"></a>00089     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+16]) {
<a name="l00090"></a>00090 
<a name="l00091"></a>00091       <span class="comment">/* only collect cubic Hk if &#39;grain&#39; has cubic Hk */</span>
<a name="l00092"></a>00092       PetscReal k1,k2,jsi;
<a name="l00093"></a>00093       jsi=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4];
<a name="l00094"></a>00094       <span class="comment">/* FIXME: why 1e-20? */</span>
<a name="l00095"></a>00095       jsi /= (jsi*jsi+1.e-20);
<a name="l00096"></a>00096       k1=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+2]*jsi;
<a name="l00097"></a>00097       k2=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+3]*jsi;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099       <span class="comment">/* a-axis of cubic crystal */</span>
<a name="l00100"></a>00100       PetscReal ax,ay,az;
<a name="l00101"></a>00101       ax=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+6];
<a name="l00102"></a>00102       ay=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+7];
<a name="l00103"></a>00103       az=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+8];
<a name="l00104"></a>00104 
<a name="l00105"></a>00105       <span class="comment">/* b-axis of cubic crystal */</span>
<a name="l00106"></a>00106       PetscReal bx,by,bz;
<a name="l00107"></a>00107       bx=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+10];
<a name="l00108"></a>00108       by=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+11];
<a name="l00109"></a>00109       bz=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+12];
<a name="l00110"></a>00110 
<a name="l00111"></a>00111       <span class="comment">/* c-axis of cubic crystal */</span>
<a name="l00112"></a>00112       PetscReal cx,cy,cz;
<a name="l00113"></a>00113       cx=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+13];
<a name="l00114"></a>00114       cy=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+14];
<a name="l00115"></a>00115       cz=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+15];
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       <span class="comment">/* get components of M */</span>
<a name="l00118"></a>00118       PetscReal mx,my,mz;
<a name="l00119"></a>00119       mx=ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0];
<a name="l00120"></a>00120       my=ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1];
<a name="l00121"></a>00121       mz=ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2];
<a name="l00122"></a>00122 
<a name="l00123"></a>00123       <span class="comment">/* direction cosines and their squares */</span>
<a name="l00124"></a>00124       PetscReal a1,a2,a3;
<a name="l00125"></a>00125       a1=mx*ax+my*ay+mz*az;
<a name="l00126"></a>00126       a2=mx*bx+my*by+mz*bz;
<a name="l00127"></a>00127       a3=mx*cx+my*cy+mz*cz;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129       PetscReal a12,a22,a32;
<a name="l00130"></a>00130       a12=a1*a1;
<a name="l00131"></a>00131       a22=a2*a2;
<a name="l00132"></a>00132       a32=a3*a3;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       <span class="comment">/* a_i ( K1 (a_j^2 a_k^2) + K2 a_j^2 a_k^2) and permutations */</span>
<a name="l00135"></a>00135       PetscReal b1,b2,b3;
<a name="l00136"></a>00136       b1=-2.0*a1*(k1*(a22+a32)+k2*a22*a32);
<a name="l00137"></a>00137       b2=-2.0*a2*(k1*(a12+a32)+k2*a12*a32);
<a name="l00138"></a>00138       b3=-2.0*a3*(k1*(a12+a22)+k2*a12*a22);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <span class="comment">/* assemble cubic H components */</span>
<a name="l00141"></a>00141       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0] = ax*b1+bx*b2+cx*b3;
<a name="l00142"></a>00142       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1] = ay*b1+by*b2+cy*b3;
<a name="l00143"></a>00143       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2] = az*b1+bz*b2+cz*b3;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>      Ecubic +=
<a name="l00147"></a>00147         (k1*(a12*a22+a12*a32+a22*a32)+k2*a12*a22*a32)*ta_VMs3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0];
<a name="l00148"></a>00148     }
<a name="l00149"></a>00149     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+3] != 0.0) {
<a name="l00150"></a>00150       PetscReal k2,jsi;
<a name="l00151"></a>00151       <span class="comment">/* might as well do uniaxial k2 term... */</span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153       jsi=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4];
<a name="l00154"></a>00154       jsi /= (jsi*jsi+1.e-20);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       <span class="comment">/* k2/Js */</span>
<a name="l00157"></a>00157       k2=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+3]*jsi;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159       <span class="comment">/* easy axis of uniaxial crystal */</span>
<a name="l00160"></a>00160       PetscReal ax,ay,az;
<a name="l00161"></a>00161       ax=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+6];
<a name="l00162"></a>00162       ay=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+7];
<a name="l00163"></a>00163       az=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+8];
<a name="l00164"></a>00164 
<a name="l00165"></a>00165       PetscReal a1,a2;
<a name="l00166"></a>00166       a1=ax*ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0]+ay*ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1]+az*ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2];  <span class="comment">/* m.k */</span>
<a name="l00167"></a>00167       <span class="comment">/* field magnitude: 4 k2 (m.k) (1-(m.k)^2) / Js */</span>
<a name="l00168"></a>00168       a2=4.0*k2*a1*(1.0-a1*a1);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170       <span class="comment">/* energy: k2(1-(m.k)^2)^2 * volume */</span>
<a name="l00171"></a>00171       Ecubic += k2*(1.0-a1*a1)*(1.0-a1*a1)*ta_VMs3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0];
<a name="l00172"></a>00172 
<a name="l00173"></a>00173       <span class="comment">/* assemble cubic H components */</span>
<a name="l00174"></a>00174       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0] = ax*a2;
<a name="l00175"></a>00175       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1] = ay*a2;
<a name="l00176"></a>00176       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2] = az*a2;
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>    }
<a name="l00179"></a>00179     <span class="keywordflow">else</span> {
<a name="l00180"></a>00180       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0] = 0.0;
<a name="l00181"></a>00181       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1] = 0.0;
<a name="l00182"></a>00182       ta_Hcubic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2] = 0.0;
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184   }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00187"></a>00187   ierr = VecRestoreArray(VHcubic,&amp;ta_Hcubic);CHKERRQ(ierr);
<a name="l00188"></a>00188 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>  ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;ta_VMs3);CHKERRQ(ierr);
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>
<a name="l00192"></a>00192   ierr = VecAXPY(VHtotsum,1.0,VHcubic);CHKERRQ(ierr);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="hcubic_8c.html#aea497be5e9a188c3f1627b6692951515">00198</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#aea497be5e9a188c3f1627b6692951515">Hcubic_Energy</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VMom,PetscReal *energy)
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200   PetscReal e;
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00205"></a>00205     *energy=0.0;
<a name="l00206"></a>00206     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00207"></a>00207   }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>  ierr = PetscGlobalSum(&amp;Ecubic,&amp;e,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00211"></a>00211 <span class="preprocessor">#else</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>  <span class="comment">/* only correct if K2=0, otherwise K2 term scaled by -1/6, not -1/4 */</span>
<a name="l00213"></a>00213   ierr = VecDot(VMom,VHcubic,&amp;e);CHKERRQ(ierr);
<a name="l00214"></a>00214   e /= -4.0;
<a name="l00215"></a>00215 <span class="preprocessor">#endif</span>
<a name="l00216"></a>00216 <span class="preprocessor"></span>
<a name="l00217"></a>00217   *energy=e;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

